from typing import TypedDict


class NestedTimeslot(TypedDict):
    end: str
    id: int | None
    is_virtual: bool
    memo: str
    playlist_id: int | None
    repetition_of_id: int | None
    start: str


class NestedShow(TypedDict):
    default_playlist_id: int | None
    id: int
    name: str


class NestedSchedule(TypedDict):
    id: int | None
    default_playlist_id: int | None


class NestedEpisode(TypedDict):
    id: int | None
    title: str


class DayScheduleEntry(TypedDict):
    episode: NestedEpisode
    timeslot: NestedTimeslot
    show: NestedShow


class TimerangeEntry(TypedDict):
    episode: NestedEpisode
    schedule: NestedSchedule | None
    show: NestedShow
    timeslot: NestedTimeslot
